int led_pin = 9;
int pot_pin = A5;
//int pot_pin2 = A1;
int output;
float current;
int led_value;
#define VIN A1 // define the Arduino pin A0 as voltage input (V in)
const float VCC   = 5.0;// supply voltage 5V or 3.3V. If using PCB, set to 5V only.
const int model = 3;   // enter the model (see below)

float cutOffLimit = 100.00;// reading cutt off current. 1.00 is 1 Amper

/*
          "ACS758LCB-050B",// for model use 0
          "ACS758LCB-050U",// for model use 1
          "ACS758LCB-100B",// for model use 2
          "ACS758LCB-100U",// for model use 3
          "ACS758KCB-150B",// for model use 4
          "ACS758KCB-150U",// for model use 5
          "ACS758ECB-200B",// for model use 6
          "ACS758ECB-200U"// for model use  7
  sensitivity array is holding the sensitivy of the  ACS758
  current sensors. Do not change.
*/
float sensitivity[] = {
  40.0,// for ACS758LCB-050B
  60.0,// for ACS758LCB-050U
  20.0,// for ACS758LCB-100B
  40.0,// for ACS758LCB-100U
  13.3,// for ACS758KCB-150B
  16.7,// for ACS758KCB-150U
  10.0,// for ACS758ECB-200B
  20.0,// for ACS758ECB-200U
};

/*
     quiescent Output voltage is factor for VCC that appears at output
     when the current is zero.
     for Bidirectional sensor it is 0.5 x VCC
     for Unidirectional sensor it is 0.12 x VCC
     for model ACS758LCB-050B, the B at the end represents Bidirectional (polarity doesn't matter)
     for model ACS758LCB-100U, the U at the end represents Unidirectional (polarity must match)
      Do not change.
*/
float quiescent_Output_voltage [] = {
  0.5,// for ACS758LCB-050B
  0.12,// for ACS758LCB-050U
  0.5,// for ACS758LCB-100B
  0.12,// for ACS758LCB-100U
  0.5,// for ACS758KCB-150B
  0.12,// for ACS758KCB-150U
  0.5,// for ACS758ECB-200B
  0.12,// for ACS758ECB-200U
};
const float FACTOR = sensitivity[model] / 1000; // set sensitivity for selected model
const float QOV =   quiescent_Output_voltage [model] * VCC;// set quiescent Output voltage for selected model
float voltage;// internal variable for voltage
float cutOff = FACTOR / cutOffLimit; // convert current cut off to mV


void setup() {
  pinMode(led_pin, OUTPUT);
  Serial.begin (115200);
  //Robojax.com ACS758 Current Sensor
  // Serial.begin(9600);// initialize serial monitor
  Serial.println("Robojax Tutorial");
  Serial.println("ACS758 Current Sensor");

}
void loop() {
  //Reading from potentiometer
  output = analogRead(pot_pin);
  // current = analogRead(pot_pin2);
  //Mapping the Values between 0 to 255 because we can give output
  //from 0 -255 using the analogwrite funtion
  led_value = map(output, 0, 1023, 0, 255);
  analogWrite(led_pin, led_value);
  //  delay(1000);
  Serial.println (current);
  //Robojax.com ACS758 Current Sensor
  float voltage_raw =   (5.0 / 1023.0) * analogRead(VIN); // Read the voltage from sensor
  voltage =  voltage_raw - QOV + 0.007 ;// 0.007 is a value to make voltage zero when there is no current
  float current = voltage / FACTOR;
  if (abs(voltage) > cutOff ) {
    Serial.print("V: ");
    Serial.print(voltage, 3); // print voltage with 3 decimal places
    Serial.print("V, I: ");
    Serial.print(current, 2); // print the current with 2 decimal places
    Serial.println("A");
  } else {
    Serial.println("No Current");
  }
  delay(500);
}
